Subject: multipart/related with "cid:" image not shown

From: Stefan Monnier <[email-masked]>
Date: Wed, 22 Oct 2014 10:01:21 -0400

Package: Emacs,gnus
Version: 24.4.51

[ This also affects trunk, and has probably been going on for a while
  now.  ]

I regularly receive emails that contain "a tiny bit of HTML text around
a picture".  Often these have the following MIME structure:

    multipart/related
      multipart/alternative
        text/plain
        text/html
      image/jpeg

where the HTML refers to the image via a "cid:" URL.

Here's the problem: Gnus seems to only show me the first element of the
multipart/related and does not let me get access to the image.

More specifically, I get a display such as:

   From: "Toto" <[email-masked]>
   Subject: blabla
   To: Stefan Monnier <[email-masked]>
   Date: Wed, 22 Oct 2014 12:59:18 +0000 (47 minutes, 13 seconds ago)
   
   1.  (*) text/plain          ( ) text/html           
   
   Mira esto

Notice the lack of any button to view the image/jpeg subpart.
The same problem shows up if I select the text/html:

   From: "Toto" <[email-masked]>
   Subject: blabla
   To: Stefan Monnier <[email-masked]>
   Date: Wed, 22 Oct 2014 12:59:18 +0000 (47 minutes, 13 seconds ago)
   
   1.  ( ) text/plain          (*) text/html           
   
       Mira esto
       
   *

It looks marginally different because it's rendered by shr.el, but the
problem remains that I have no access to the attached image.

        Stefan